// http://eslint.org/docs/user-guide/configuring

module.exports = {
  root: true,
  parser: "babel-eslint",
  parserOptions: {
    ecmaVersion: 7,
    sourceType: "module",
    ecmaFeatures: {
      jsx: true
    }
  },
  env: {
    browser: true,
    es6: true
  },
  // https://github.com/feross/standard/blob/master/RULES.md#javascript-standard-style
  extends: "standard",
  plugins: ["react"],
  // add your custom rules here
  rules: {
    // allow paren-less arrow functions
    "arrow-parens": 0,
    quotes: 0,
    semi: 0,
    'no-unused-vars': 0,
    // allow async-await
    // 'generator-star-spacing': 0,
    "react/jsx-uses-vars": [2],
    "react/jsx-uses-react": 2,
    "react/react-in-jsx-scope": 2,
    "import/no-webpack-loader-syntax": 0,
    "space-before-function-paren": 0,
    // allow debugger during development
    "no-debugger": process.env.NODE_ENV === "production" ? 2 : 0
  }
};
