#### 基本使用

``` js
<Slider onChange={console.log} defaultValue={[20, 50]}/>
```

设置边界和步长

``` js
<Slider min={10} max={50} step={5}
  onChange={console.log} defaultValue={[20, 30]}/>
```

自定义点

``` js
const Popover = require('../Popover').default
const Handle = Slider.Handle
const handle = ({ value, index, ...restProps }) => {
  return <Popover content={value} position="top">
    <Handle {...restProps} key={index} />
  </Popover>
}
<Slider
  handle={handle}
  onChange={console.log} defaultValue={[20, 30]}/>
```

禁用状态
``` js
<Slider disabled onChange={console.log} defaultValue={[20, 50]}/>
```

允许交叉
``` js
<Slider allowCross onChange={console.log} defaultValue={[20, 50]}/>
```